package com.kingdee.eas.hr.perf.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.swing.StringUtils;
import com.kingdee.bos.dao.ObjectNotFoundException;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryCollection;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryFactory;
import com.kingdee.eas.hr.affair.EmpEnrollBizBillEntryInfo;
import com.kingdee.eas.hr.affair.IEmpEnrollBizBillEntry;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsBody;
import com.kingdee.shr.base.syssetting.api.bean.BatchMessageTipsHeader;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.shr.base.syssetting.util.LocaleUtils;
import com.kingdee.shr.base.syssetting.web.handler.ListHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.perfweb.app.base.evalfile.IPerfFile;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileCollection;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileFactory;
import com.kingdee.shr.perfweb.app.base.evalfile.PerfFileInfo;
import com.kingdee.shr.perfweb.app.base.evalplan.*;
import com.kingdee.shr.perfweb.app.base.evalrule.PWorkFlowDefCollection;
import com.kingdee.shr.perfweb.app.base.evalrule.PWorkFlowDefInfo;
import com.kingdee.shr.perfweb.app.base.evalrule.PerformanceRuleInfo;
import com.kingdee.shr.perfweb.app.exception.SHRPerfWebBizException;
import com.kingdee.shr.perfweb.app.resource.SHRPerfWebResource;
import com.kingdee.shr.perfweb.evaluplan.handler.PerfEvaluObjectListHandler;
import com.kingdee.shr.perfweb.util.PersonInchargeUtils;
import com.kingdee.shr.perfweb.util.SHRPerfWebResourceUtil;
import com.kingdee.shr.perfweb.utils.PerfPlanUtils;
import com.kingdee.shr.perfweb.utils.RuleHistoryUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.ui.ModelMap;
import org.springframework.util.CollectionUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.Year;
import java.util.*;

/**
 * @author qingwu
 * @date 2024/12/17
 * @apiNote
 */
public class PerfEvaluObjectListHandlerEx extends PerfEvaluObjectListHandler {
    //public class PerfEvaluObjectListHandlerEx extends ListHandler {
    private Context ctx = SHRContext.getInstance().getContext();
    private static Logger logger = LoggerFactory.getLogger(PerfEvaluObjectListHandlerEx.class);

    public void addEvaluObjectExAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, SHRWebException, EASBizException {
        addPerfEvaObject("", 0);
    }

    public void addPerfEvaObject(String billid, int day) throws BOSException, SHRWebException, EASBizException {
        logger.error("addPerfEvaObject----");
        StringBuilder perfFiles = new StringBuilder();//ڵid
        if (!StringUtils.isEmpty(billid)) {
            perfFiles.append(billid);
        }
        // ȡǰ
        LocalDate currentDate = LocalDate.now();
        LocalDate threeDaysBefore = null;
        if (day != 0) {
            // ȡǰǰ
            threeDaysBefore = currentDate.minusDays(day);
        } else {
            threeDaysBefore = currentDate.minusDays(3);
        }
        logger.error("addPerfEvaObject----1");
        Date date = java.sql.Date.valueOf(threeDaysBefore);
        //ְ  ȡְԱ ͨԱidȥѯЧid
        IEmpEnrollBizBillEntry iEmpEnrollBizBillEntry = EmpEnrollBizBillEntryFactory.getLocalInstance(ctx);
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("bizDate");
        sic.add("empname");
        sic.add("person.id");
        sic.add("person.number");
        sic.add("person.name");
        FilterInfo empEnrollFilterInfo = new FilterInfo();
        empEnrollFilterInfo.getFilterItems().add(new FilterItemInfo("bizDate", threeDaysBefore.toString(), CompareType.GREATER_EQUALS));
        EntityViewInfo empEnrollEntityViewInfo = EntityViewInfo.getInstance(empEnrollFilterInfo, null, null);
        EmpEnrollBizBillEntryCollection empEnrollBizBillEntryCollection = iEmpEnrollBizBillEntry.getEmpEnrollBizBillEntryCollection(empEnrollEntityViewInfo);
        logger.error("addPerfEvaObject----2");
        Set set = new HashSet();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < empEnrollBizBillEntryCollection.size(); i++) {
            EmpEnrollBizBillEntryInfo empEnrollBizBillEntryInfo = empEnrollBizBillEntryCollection.get(i);
            String empName = empEnrollBizBillEntryInfo.getEmpName();
            PersonInfo person = empEnrollBizBillEntryInfo.getPerson();
            set.add(person.getId());
            sb.append(empName).append(",");
        }
        logger.error("addPerfEvaObject----3");
        sb = deleteCharAt(sb);
        //Ч˵ ȡЧidԱ˼ƻ
        IPerfFile iPerfFile = PerfFileFactory.getLocalInstance(ctx);
        FilterInfo perfFileFilterInfo = new FilterInfo();
        perfFileFilterInfo.getFilterItems().add(new FilterItemInfo("person", set, CompareType.INCLUDE));
        EntityViewInfo perfFileEntityViewInfo = EntityViewInfo.getInstance(perfFileFilterInfo, null, null);
        PerfFileCollection perfFileCollection = iPerfFile.getPerfFileCollection(perfFileEntityViewInfo);
        if (perfFileCollection.size() <= 0) {
            throw new ShrWebBizException("[" + sb.toString() + "]ЩԱδԱЧά");
        }
        for (int i = 0; i < perfFileCollection.size(); i++) {
            PerfFileInfo perfFileInfo = perfFileCollection.get(i);
            perfFiles.append(perfFileInfo.getId().toString()).append(",");
        }
        perfFiles = deleteCharAt(perfFiles);
        //  ִӲ
        IPerfPeriod iPerfPeriod = PerfPeriodFactory.getLocalInstance(ctx);
        //ȡǰ
        int year = Year.now().getValue();
        PerfPeriodInfo perfPeriodInfo = iPerfPeriod.getPerfPeriodInfo("where timePeriod = '" + year + "' and name = '˾ȼЧĿ_" + year + "'");
        PerfPlanInfo perfPlan = perfPeriodInfo.getPerfPlan();
        String planId = perfPlan.getId().toString();
        String periodId = perfPeriodInfo.getId().toString();
        String addModel = "0";
        String hrOrgUnit = "00000000-0000-0000-0000-000000000000CCE7AED4";
        checkPeriod(periodId);
        PerfPlanInfo info = null;
        logger.error("addPerfEvaObject----4");
        try {
            info = PerfPlanFactory.getRemoteInstance().getPerfPlanInfo("where id = '" + planId + "'");
        } catch (Exception var10) {
            var10.printStackTrace();
            logger.error(var10.toString());
            throw new ShrWebBizException((new SHRPerfWebBizException(SHRPerfWebBizException.GETPERFPLANERR)).getMessage());
        }
        logger.error("addPerfEvaObject----5" + addModel);
        if ("0".equals(addModel)) {
            logger.error("addFromPerfFile----" + info.getId());
            this.addFromPerfFile(perfFiles.toString(), periodId, hrOrgUnit, info);
        }
    }

    public StringBuilder deleteCharAt(StringBuilder sb) {
        if (sb.length() > 0) {
            sb.deleteCharAt(sb.lastIndexOf(","));
        }
        return sb;

    }


    public void addFromPerfFile(String perfFiles, String periodId, String hrOrgUnit, PerfPlanInfo perfPlan) throws SHRWebException {
        logger.error("addFromPerfFile----");
        String billId = perfFiles;
        //String billId = "nJsYSsgcTvqTNTFmY+YCRFulBK0=";
        checkPeriod(periodId);
        String[] ids = null;
        ids = billId.split(",");
        Set<String> set = new HashSet();
        set.addAll(Arrays.asList(ids));
        EntityViewInfo viewInfo = new EntityViewInfo();
        FilterInfo filter = new FilterInfo();
        SelectorItemCollection sic = viewInfo.getSelector();
        sic.add(new SelectorItemInfo("*"));
        sic.add(new SelectorItemInfo("position.id"));
        sic.add(new SelectorItemInfo("adminOrgUnit.id"));
        sic.add(new SelectorItemInfo("hrOrgUnit.id"));
        sic.add(new SelectorItemInfo("person.number"));
        sic.add(new SelectorItemInfo("person.name"));
        sic.add(new SelectorItemInfo("empPosOrgRelation.*"));
        filter.getFilterItems().add(new FilterItemInfo("id", set, CompareType.INCLUDE));
        viewInfo.setFilter(filter);
        PerfFileCollection coll = null;
        PerfGoalsGroupCollection groupColl = null;
        String groupId = "";
        PWorkFlowDefInfo defaultWorkFlow = null;

        try {
            coll = PerfFileFactory.getRemoteInstance().getPerfFileCollection(viewInfo);
            groupColl = PerfGoalsGroupFactory.getRemoteInstance().getPerfGoalsGroupCollection("where period = '" + periodId + "' and useDefault = 1");
            if (groupColl != null && groupColl.get(0) != null) {
                groupId = groupColl.get(0).getId().toString();
            }

            PerfPeriodInfo perfPeriodInfo = PerfPeriodFactory.getRemoteInstance().getPerfPeriodInfo("where id = '" + periodId + "'");
            PerformanceRuleInfo perfRule = perfPeriodInfo.getPerfRule();
            PWorkFlowDefCollection pWFDefColl = RuleHistoryUtils.getDefaultWorkFlow(this.ctx, perfRule.getId().toString());
            if (pWFDefColl != null && pWFDefColl.size() > 0) {
                defaultWorkFlow = pWFDefColl.get(0);
            } else if (perfPeriodInfo.getIsHistoryUpdate().getValue() == 1) {
                defaultWorkFlow = perfPlan.getDefaultWorkFlow();
            }
        } catch (BOSException var20) {
            var20.printStackTrace();
            logger.error(var20.toString());
        } catch (EASBizException var21) {
            var21.printStackTrace();
            logger.error(var21.toString());
        }

        if (coll != null && defaultWorkFlow != null) {
            CoreBaseCollection croeBase = new CoreBaseCollection();

            for (int i = 0; i < coll.size(); ++i) {
                PerfEvaObjectInfo info = new PerfEvaObjectInfo();
                PerfFileInfo fileInfo = coll.get(i);
                info.put("number", fileInfo.getPerson().getNumber());
                info.setName(fileInfo.getPerson().getName());
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l1), LocaleUtils.locale_l1);
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l2), LocaleUtils.locale_l2);
                info.setName(fileInfo.getPerson().getName(LocaleUtils.locale_l3), LocaleUtils.locale_l3);
                info.put("period", periodId);
                info.setCanAdjustEvaluer(TargetEvaluModeEnum.getEnum(perfPlan.getCanAdjustEvaluer().getValue()));
                info.setHrUnitOrg(fileInfo.getHrOrgUnit());
                info.setPerfFile(fileInfo);
                info.setAdminOrgUnit(fileInfo.getAdminOrgUnit());
                info.put("person", fileInfo.getPerson());
                info.put("joinPeriodDate", new Date());
                info.put("joinPlanDate", new Date());
                info.put("changeDealType", 100);
                info.put("workFlow", defaultWorkFlow.getId().toString());
                info.put("unitGoalsStatus", "0");
                info.put("belongGroup", groupId);
                info.setScoreTaskStatus(ScoreTaskStatusEnum.UNSEND);
                info.setTargetMakeSure(perfPlan.isTargetMakeSure() ? 1 : 0);
                info.setPersonInChargeType(PersonInchargeUtils.setSuperior2PersonInChargeType(info.getPersonInChargeType()));
                info.setPersonInchargePosition((String) null);
                info.setPointPosition((String) null);
                info.put("personIncharge", new PerfEvaPersonInchargeCollection());
                croeBase.add(info);
            }

            this.runBatchSaveEvaObject(periodId, hrOrgUnit, croeBase);
        } else {
            throw new SHRWebException((new SHRPerfWebBizException(SHRPerfWebBizException.GETERR)).getMessage());
        }
    }

    protected void runBatchSaveEvaObject(String periodId, String hrOrgUnit, CoreBaseCollection croeBase) throws SHRWebException {
        logger.error("runBatchSaveEvaObject----");
        int sucess = 0;
        int failure = 0;
        String billId = "";
        try {
            Set<String> sucessIds = new HashSet();
            Map<String, String> verifyMap = new HashMap();
            Map<String, String> evaPlanNameMap = this.getPerfPlanName(periodId, hrOrgUnit);
            CoreBaseCollection addCoreColl = new CoreBaseCollection();
            int count = croeBase.size();
            int j = 1;
            Set<String> personIds = new HashSet();

            int i;
            PerfEvaObjectInfo info;
            for (i = 0; i < count; ++i) {
                info = (PerfEvaObjectInfo) croeBase.get(i);
                personIds.add(info.getPerson().getId().toString());
                if (j != 500 && i != count - 1) {
                    ++j;
                } else {
                    Map<String, String> tempMap = this.getEvaObject(periodId, hrOrgUnit, personIds);
                    if (!CollectionUtils.isEmpty(tempMap)) {
                        verifyMap.putAll(tempMap);
                    }

                    j = 1;
                    personIds = new HashSet();
                }
            }

            for (i = 0; i < croeBase.size(); ++i) {
                info = (PerfEvaObjectInfo) croeBase.get(i);
                BatchMessageTipsBody body = new BatchMessageTipsBody();

                try {
                    String id = info.getPerfFile().getId().toString();
                    billId = billId + id + ",";
                    body.setId(id);
                    if (sucessIds.contains(id)) {
                        continue;
                    }

                    sucessIds.add(id);

                    String key = info.getPerson().getNumber() + "_" + info.getPerson().getName() + "_" + info.getPerfFile().getPosition().getId().toString() + "_" + info.getPerfFile().getAssignType().getValue();
                    if (!org.apache.commons.lang.StringUtils.isEmpty((String) verifyMap.get(key))) {
                        continue;
                        //throw new BOSException((new SHRPerfWebBizException(SHRPerfWebBizException.EVAOBJALREADYADDED, new Object[]{evaPlanNameMap.get(verifyMap.get(key))})).getMessage());
                    }

                    addCoreColl.add(info);
                    ++sucess;
                    body.setMuitTipsState(Boolean.TRUE);
                    body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.OPERATESUCCESS, this.ctx));
                } catch (Exception var23) {
                    var23.printStackTrace();
                    croeBase.removeObject(i);
                    --i;
                    ++failure;
                    body.setMuitTipsState(Boolean.FALSE);
                    if (var23 instanceof ObjectNotFoundException) {
                        body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.DATADELETED, this.ctx));
                    } else {
                        body.setMuitTipsMessage(SHRPerfWebResourceUtil.getRes(SHRPerfWebResource.OPERATEFAILED, this.ctx));
                    }

                    logger.error(var23.getMessage(), var23);
                }

                if (addCoreColl.size() == 100) {
                    PerfEvaObjectFactory.getRemoteInstance().saveBatchData(addCoreColl);
                    addCoreColl.clear();
                }
            }

            if (addCoreColl.size() > 0) {
                PerfEvaObjectFactory.getRemoteInstance().saveBatchData(addCoreColl);
                addCoreColl.clear();
            }

            if (sucess > 0) {
                PerfPlanUtils.writeRefStateForPerfPeriod(this.ctx, periodId, RefStatusEnum.REFERED);
            }
        } catch (Exception var24) {
            logger.error("runBatchSaveEvaObject----" + var24);
            var24.printStackTrace();
            throw new SHRWebException(var24.getMessage(), var24);
        }
        logger.error("runBatchSaveEvaObject----end");

    }

}
